DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP > Class Template Reference

Integer-based GroupParameters default implementation. More...

`#include <gfpcrypt.h>`

Inheritance diagram for DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >:

## Public Types

typedef GROUP_PRECOMP::Element | Element
Public Types inherited from DL_GroupParametersImpl< GROUP_PRECOMP, BASE_PRECOMP, BASE >
typedef GROUP_PRECOMP | GroupPrecomputation
typedef GROUP_PRECOMP::Element | Element
typedef BASE_PRECOMP | BasePrecomputation
Public Types inherited from DL_GroupParameters< T >
typedef T | Element

## Public Member Functions

bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| Get a named value.
void | AssignFrom (const NameValuePairs &source)
| Assign values to this object.
const DL_FixedBasePrecomputation< Element > & | GetBasePrecomputation () const
| Retrieves the group precomputation.
DL_FixedBasePrecomputation< Element > & | AccessBasePrecomputation ()
| Retrieves the group precomputation.
const Integer & | GetModulus () const
| Retrieve the modulus for the group.
const Integer & | GetGenerator () const
| Retrieves a reference to the group generator.
void | SetModulusAndSubgroupGenerator (const Integer &p, const Integer &g)
bool | operator== (const DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP > &rhs) const
bool | operator!= (const DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP > &rhs) const
Public Member Functions inherited from DL_GroupParametersImpl< GROUP_PRECOMP, BASE_PRECOMP, BASE >
const DL_GroupPrecomputation< Element > & | GetGroupPrecomputation () const
| Retrieves the group precomputation.
const DL_FixedBasePrecomputation< Element > & | GetBasePrecomputation () const
| Retrieves the group precomputation.
DL_FixedBasePrecomputation< Element > & | AccessBasePrecomputation ()
| Retrieves the group precomputation.
Public Member Functions inherited from DL_GroupParameters< T >
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
bool | SupportsPrecomputation () const
| Determines whether the object supports precomputation.
void | Precompute (unsigned int precomputationStorage=16)
| Perform precomputation.
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| Retrieve previously saved precomputation.
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| Save precomputation for later use.
virtual const Element & | GetSubgroupGenerator () const
| Retrieves the subgroup generator.
virtual void | SetSubgroupGenerator (const Element &base)
| Sets the subgroup generator.
virtual Element | ExponentiateBase (const Integer &exponent) const
| Exponentiates the base.
virtual Element | ExponentiateElement (const Element &base, const Integer &exponent) const
| Exponentiates an element.
virtual const Integer & | GetSubgroupOrder () const =0
| Retrieves the subgroup order.
virtual Integer | GetMaxExponent () const =0
| Retrieves the maximum exponent for the group.
virtual Integer | GetGroupOrder () const
| Retrieves the order of the group.
virtual Integer | GetCofactor () const
| Retrieves the cofactor.
virtual unsigned int | GetEncodedElementSize (bool reversible) const =0
| Retrieves the encoded element's size.
virtual void | EncodeElement (bool reversible, const Element &element, byte *encoded) const =0
| Encodes the element.
virtual Element | DecodeElement (const byte *encoded, bool checkForGroupMembership) const =0
| Decodes the element.
virtual Integer | ConvertElementToInteger (const Element &element) const =0
| Converts an element to an Integer.
virtual bool | ValidateGroup (RandomNumberGenerator &rng, unsigned int level) const =0
| Check the group for errors.
virtual bool | ValidateElement (unsigned int level, const Element &element, const DL_FixedBasePrecomputation< Element > *precomp) const =0
| Check the element for errors.
virtual bool | FastSubgroupCheckAvailable () const =0
virtual bool | IsIdentity (const Element &element) const =0
| Determines if an element is an identity.
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const =0
| Exponentiates a base to multiple exponents.
Public Member Functions inherited from GeneratableCryptoMaterial
virtual void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &params=g_nullNameValuePairs)
| Generate a random key or crypto parameters.
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| Generate a random key or crypto parameters.
Public Member Functions inherited from CryptoMaterial
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| Check this object for errors.
virtual void | Save (BufferedTransformation &bt) const
| Saves a key to a BufferedTransformation.
virtual void | Load (BufferedTransformation &bt)
| Loads a key from a BufferedTransformation.
void | DoQuickSanityCheck () const
| Perform a quick sanity check.
Public Member Functions inherited from NameValuePairs
template<class T >
bool | GetThisObject (T &object) const
| Get a copy of this object or subobject.
template<class T >
bool | GetThisPointer (T *&ptr) const
| Get a pointer to this object.
template<class T >
bool | GetValue (const char *name, T &value) const
| Get a named value.
template<class T >
T | GetValueWithDefault (const char *name, T defaultValue) const
| Get a named value.
CRYPTOPP_DLL std::string | GetValueNames () const
| Get a list of value names that can be retrieved.
CRYPTOPP_DLL bool | GetIntValue (const char *name, int &value) const
| Get a named value with type int.
CRYPTOPP_DLL int | GetIntValueWithDefault (const char *name, int defaultValue) const
| Get a named value with type int, with default.
CRYPTOPP_DLL bool | GetWord64Value (const char *name, word64 &value) const
| Get a named value with type word64.
CRYPTOPP_DLL word64 | GetWord64ValueWithDefault (const char *name, word64 defaultValue) const
| Get a named value with type word64, with default.
template<class T >
void | GetRequiredParameter (const char *className, const char *name, T &value) const
| Retrieves a required name/value pair.
CRYPTOPP_DLL void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
| Retrieves a required name/value pair.

## Additional Inherited Members

Static Public Member Functions inherited from NameValuePairs
static CRYPTOPP_DLL void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| Ensures an expected name and type is present.

## Detailed Description

template<class GROUP_PRECOMP, class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>
class DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >

Integer-based GroupParameters default implementation.

Template Parameters

  GROUP_PRECOMP | group parameters precomputation specialization
  BASE_PRECOMP | base class precomputation specialization

Definition at line 182 of file gfpcrypt.h.

## Member Typedef Documentation

## Element

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

typedef GROUP_PRECOMP::Element DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::Element

Definition at line 187 of file gfpcrypt.h.

## Constructor & Destructor Documentation

## ~DL_GroupParameters_IntegerBasedImpl()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

virtual DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::~DL_GroupParameters_IntegerBasedImpl | ( |  | ) |

inline virtual

Definition at line 189 of file gfpcrypt.h.

## Member Function Documentation

## GetVoidValue()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

bool DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::GetVoidValue | ( | const char * | name,
|  | const std::type_info & | valueType,
|  | void * | pValue
| ) |  | const

inline virtual

Get a named value.

Parameters

  name | the name of the object or value to retrieve
  valueType | reference to a variable that receives the value
  pValue | void pointer to a variable that receives the value

Returns
  true if the value was retrieved, false otherwise

GetVoidValue() retrieves the value of name if it exists.

Note
  GetVoidValue() is an internal function and should be implemented by derived classes. Users should use one of the other functions instead.

See also
  GetValue(), GetValueWithDefault(), GetIntValue(), GetIntValueWithDefault(), GetRequiredParameter() and GetRequiredIntParameter()

Reimplemented from DL_GroupParameters< T >.

Reimplemented in DL_GroupParameters_LUC.

Definition at line 192 of file gfpcrypt.h.

## AssignFrom()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

void DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::AssignFrom | ( | const NameValuePairs & | source | ) |

inline virtual

Assign values to this object.

This function can be used to create a public key from a private key.

Implements CryptoMaterial.

Definition at line 195 of file gfpcrypt.h.

## GetBasePrecomputation()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

const DL_FixedBasePrecomputation< Element > & DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::GetBasePrecomputation | ( |  | ) | const

inline virtual

Retrieves the group precomputation.

Returns
  a const reference to the group precomputation using a fixed base

Implements DL_GroupParameters< T >.

Definition at line 199 of file gfpcrypt.h.

## AccessBasePrecomputation()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

DL_FixedBasePrecomputation< Element > & DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::AccessBasePrecomputation | ( |  | ) |

inline virtual

Retrieves the group precomputation.

Returns
  a non-const reference to the group precomputation using a fixed base

Implements DL_GroupParameters< T >.

Definition at line 200 of file gfpcrypt.h.

## GetModulus()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

const Integer & DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::GetModulus | ( |  | ) | const

inline

Retrieve the modulus for the group.

Returns
  the modulus for the group

Definition at line 205 of file gfpcrypt.h.

## GetGenerator()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

const Integer & DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::GetGenerator | ( |  | ) | const

inline

Retrieves a reference to the group generator.

Returns
  const reference to the group generator

Definition at line 209 of file gfpcrypt.h.

## SetModulusAndSubgroupGenerator()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

void DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::SetModulusAndSubgroupGenerator | ( | const Integer & | p,
|  | const Integer & | g
| ) |  |

inline

Definition at line 211 of file gfpcrypt.h.

## operator==()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

bool DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::operator== | ( | const DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP > & | rhs | ) | const

inline

Definition at line 215 of file gfpcrypt.h.

## operator!=()

template<class GROUP_PRECOMP , class BASE_PRECOMP = DL_FixedBasePrecomputationImpl<typename GROUP_PRECOMP::Element>>

bool DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >::operator!= | ( | const DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP > & | rhs | ) | const

inline

Definition at line 217 of file gfpcrypt.h.

The documentation for this class was generated from the following file:

- gfpcrypt.h